module Integer = struct
    type number = int
	let string_of_number = string_of_int
    let zero = 0
    let one = 1
    let add x y = x + y
    let multiply x y = x * y
    let subtract x y = x - y
    let divide x y = x / y
    let negative x = -x

	let is_even n = n mod 2 = 0
	let pow base exponent =
	  if exponent < 0 then invalid_arg "exponent can not be negative" else
	  let rec aux accumulator base = function
		| 0 -> accumulator
		| 1 -> base * accumulator
		| e when is_even e -> aux accumulator (base * base) (e / 2)
		| e -> aux (base * accumulator) (base * base) ((e - 1) / 2) in
	  aux 1 base exponent
	end

module Expression = Expression.Expression(Integer)
