{
open Parser        (* The type token is defined in parser.mli *)
exception Eof
}
rule token = parse
  | [' ' '\t']     { token lexbuf }     (* skip blanks *)
  | '\n'             { NEWLINE }
  | ['0'-'9']+ as lxm { INT(int_of_string lxm) }
  | '+'            { PLUS }
  | '='            { EQUALS }
  | '^'            { POWER }
  | '-'            { MINUS }
  | '*'            { TIMES }
  | '/'            { DIV }
  | '('            { LPAREN }
  | ')'            { RPAREN }
  | '['            { LBRACKET }
  | ']'            { RBRACKET }
  | ','            { COMMA }
  | "true"         { TRUE }
  | "false"        { FALSE }
  | "and"          { AND }
  | "or"           { OR }
  | "not"          { NOT }
  | "is"           { IS }
  | "if"           { IF }
  | "in"           { IN }
  | "else"         { ELSE }
  | "for"          { FOR }
  | "println"      { PRINT }
  | ['a'-'z']+ as lxm { VAR(lxm) }
  | eof            { raise Eof }
