exception Unimplemented
exception InvalidResult

open Core
open Integer.Expression

let _ =
    let lexbuf = Lexing.from_channel In_channel.stdin in
        let rec loop env =
            try
                let parsed = Parser.main Lexer.token lexbuf in match parsed with 
                    | Expression expr -> 
                        Out_channel.output_string stdout ((string_of_expression expr) ^ " -> ");
                        Out_channel.output_string stdout (match (eval_expression env expr) with
                            | Boolean b -> string_of_bool b
                            | Num n -> string_of_int n
                            | List l -> Integer.Expression.string_of_expression_list l
                            | _ -> raise InvalidResult
                        ); 
                        Out_channel.newline stdout;
                        Out_channel.flush stdout; 
                        loop env 
                    | Statement stmt -> match stmt with 
                        | Assign(v, expr) -> loop (Map.set env ~key:v ~data:(eval_expression env expr)) 
                        | Print(expr) -> Out_channel.print_endline (string_of_expression (eval_expression env expr)); loop env
                        (*| _ -> raise Unimplemented *)
            with Lexer.Eof ->
                exit 0
        in loop String.Map.empty
;;
